package demo.server.service;

import java.util.ArrayList;
import java.util.List;

import org.seasar.doma.copy.CopyUtil;
import org.seasar.doma.jdbc.SelectOptions;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import demo.client.service.EmployeeService;
import demo.server.dao.EmployeeDao;
import demo.server.dao.EmployeeDao_;
import demo.server.entity.Employee;
import demo.server.entity.Employee_;
import demo.shared.dto.EmployeeDto;

/**
 * The server side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class EmployeeServiceImpl extends RemoteServiceServlet implements
        EmployeeService {

    private static int LIMMIT = 6;

    public List<EmployeeDto> selectAll() {
        EmployeeDao dao = getEmployeeDao();
        return toEmployeeDtoList(dao.selectAll());
    }

    @Override
    public List<EmployeeDto> select(int offset) {
        EmployeeDao dao = getEmployeeDao();
        SelectOptions options = SelectOptions.get().limit(LIMMIT)
                .offset(offset);
        return toEmployeeDtoList(dao.select(options));
    }

    @Override
    public void insert(EmployeeDto employeeDto) {
        EmployeeDao dao = getEmployeeDao();
        Employee employee = new Employee_();
        CopyUtil.copy(employeeDto, employee);
        dao.insert(employee);
    }

    @Override
    public void delete(EmployeeDto employeeDto) {
        EmployeeDao dao = getEmployeeDao();
        Employee employee = new Employee_();
        CopyUtil.copy(employeeDto, employee);
        dao.delete(employee);
    }

    @Override
    public void update(EmployeeDto employeeDto) {
        EmployeeDao dao = getEmployeeDao();
        Employee employee = new Employee_();
        CopyUtil.copy(employeeDto, employee);
        dao.update(employee);
    }

    protected List<EmployeeDto> toEmployeeDtoList(List<Employee> employeeList) {
        List<EmployeeDto> result = new ArrayList<EmployeeDto>();
        for (Employee employee : employeeList) {
            EmployeeDto dto = new EmployeeDto();
            CopyUtil.copy(employee, dto);
            result.add(dto);
        }
        return result;
    }

    protected EmployeeDao getEmployeeDao() {
        return new EmployeeDao_();
    }
}
